
package com.mobilevangelist.glass.helloworld;

import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.View;
import android.view.KeyEvent;
import android.widget.TextView;
import android.widget.Toast;
import android.view.MotionEvent;

import com.google.android.glass.app.Card;
import com.google.android.glass.media.Sounds;
import com.google.android.glass.touchpad.Gesture;
import com.google.android.glass.touchpad.GestureDetector;


public class HelloWorldActivity extends Activity {

  private Card _card;
  private View _cardView;
  private TextView _statusTextView;

  private TextToSpeech _speech;

  private Context _context = this;

    private GestureDetector mGestureDetector;


    @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);

    _speech = new TextToSpeech(this, new TextToSpeech.OnInitListener() {
      @Override
      public void onInit(int status) {
        _speech.speak("Hello, World", TextToSpeech.QUEUE_FLUSH, null);
      }
    });

    // An alternative way to layout the UX
    setContentView(R.layout.layout_helloworld);
    _statusTextView = (TextView)findViewById(R.id.status);
  }

  /**
   * Handle the tap event from the touchpad.
   */
  @Override
  public boolean onKeyDown(int keyCode, KeyEvent event) {
    switch (keyCode) {
    // Handle tap events.
    case KeyEvent.KEYCODE_DPAD_CENTER:
    case KeyEvent.KEYCODE_ENTER:

        mGestureDetector = createGestureDetector(this);

      return true;
    default:
      return super.onKeyDown(keyCode, event);
    }
  }

  @Override
  public void onResume() { super.onResume(); }

  @Override
  public void onPause() {  super.onPause();  }

  @Override
  public void onDestroy() { super.onDestroy(); }

    private GestureDetector createGestureDetector(Context context)
    {

        Toast.makeText( getApplicationContext(), "createGestureDetector1", Toast.LENGTH_SHORT).show();

        GestureDetector gestureDetector = new GestureDetector(context);
        //Create a base listener for generic gestures

        Toast.makeText( getApplicationContext(), "createGestureDetector2", Toast.LENGTH_SHORT).show();
        gestureDetector.setBaseListener( new GestureDetector.BaseListener() {
            @Override
            public boolean onGesture(Gesture gesture) {
                //Log.e(TAG,"gesture = " + gesture);

                Toast.makeText( getApplicationContext(), "gesture", Toast.LENGTH_SHORT).show();

                switch (gesture) {
                    case TAP:
                        Toast.makeText( getApplicationContext(), "TAP", Toast.LENGTH_SHORT).show();
                        break;
                    case LONG_PRESS:
                        Toast.makeText( getApplicationContext(), "LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_DOWN:
                        Toast.makeText( getApplicationContext(), "SWIPE_DOWN called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_LEFT:
                        Toast.makeText( getApplicationContext(), "SWIPE_LEFT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_RIGHT:
                        Toast.makeText( getApplicationContext(), "SWIPE_RIGHT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case SWIPE_UP:
                        Toast.makeText( getApplicationContext(), "SWIPE_UP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case THREE_LONG_PRESS:
                        Toast.makeText( getApplicationContext(), "THREE_LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case THREE_TAP:
                        Toast.makeText( getApplicationContext(), "THREE_TAP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_LONG_PRESS:
                        Toast.makeText( getApplicationContext(), "TWO_LONG_PRESS called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_DOWN:
                        Toast.makeText( getApplicationContext(), "TWO_SWIPE_DOWN called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_LEFT:
                        Toast.makeText( getApplicationContext(), "TWO_SWIPE_LEFT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_RIGHT:
                        Toast.makeText( getApplicationContext(), "TWO_SWIPE_RIGHT called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_SWIPE_UP:
                        Toast.makeText( getApplicationContext(), "TWO_SWIPE_UP called.", Toast.LENGTH_SHORT).show();
                        return true;
                    case TWO_TAP:
                        Toast.makeText( getApplicationContext(), "TWO_TAP called.", Toast.LENGTH_SHORT).show();
                        return true;
                }

                return false;
            }
        });
        gestureDetector.setFingerListener(new com.google.android.glass.touchpad.GestureDetector.FingerListener() {
            @Override
            public void onFingerCountChanged(int previousCount, int currentCount) {
                // do something on finger count changes
                //Log.e(TAG,"onFingerCountChanged()");


            }
        });
        gestureDetector.setScrollListener(new com.google.android.glass.touchpad.GestureDetector.ScrollListener() {
            @Override
            public boolean onScroll(float displacement, float delta, float velocity) {
                // do something on scrolling
                //Log.e(TAG,"onScroll()");
                return false;
            }
        });
        return gestureDetector;
    }

    @Override
    public boolean onGenericMotionEvent(MotionEvent event) {
        if (mGestureDetector != null) {
            return mGestureDetector.onMotionEvent(event);
        }
        return false;
    }


}